diff --git a/pengine/test10/whitebox-ms-ordering.exp b/pengine/test10/whitebox-ms-ordering.exp
index 0566f413b..7aecfbae2 100644
--- a/pengine/test10/whitebox-ms-ordering.exp
+++ b/pengine/test10/whitebox-ms-ordering.exp
@@ -16,6 +16,9 @@
       <trigger>
         <rsc_op id="9" operation="monitor" operation_key="container1_monitor_0" on_node="18node3" on_node_uuid="3"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="35" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="1">
@@ -62,6 +65,9 @@
       <trigger>
         <rsc_op id="10" operation="monitor" operation_key="container2_monitor_0" on_node="18node3" on_node_uuid="3"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="35" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="5">
@@ -111,6 +117,9 @@
       <trigger>
         <rsc_op id="31" operation="start" operation_key="lxc1_start_0" on_node="18node1" on_node_uuid="1"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="35" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="9">
@@ -130,6 +139,9 @@
       <trigger>
         <rsc_op id="31" operation="start" operation_key="lxc1_start_0" on_node="18node1" on_node_uuid="1"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="35" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="10">
@@ -154,6 +166,9 @@
       <trigger>
         <pseudo_event id="25" operation="stop" operation_key="lxc-ms-master_stop_0"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="36" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="11">
@@ -166,6 +181,9 @@
       <trigger>
         <pseudo_event id="29" operation="demote" operation_key="lxc-ms-master_demote_0"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="36" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="12">
@@ -228,6 +246,9 @@
       <trigger>
         <rsc_op id="33" operation="start" operation_key="lxc2_start_0" on_node="18node1" on_node_uuid="1"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="35" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="17">
@@ -240,6 +261,9 @@
       <trigger>
         <pseudo_event id="25" operation="stop" operation_key="lxc-ms-master_stop_0"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="37" operation="stonith" operation_key="stonith-lxc2-reboot" on_node="lxc2" on_node_uuid="lxc2"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="18" priority="1000000">
@@ -323,6 +347,12 @@
       <trigger>
         <pseudo_event id="30" operation="demoted" operation_key="lxc-ms-master_demoted_0"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="36" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="37" operation="stonith" operation_key="stonith-lxc2-reboot" on_node="lxc2" on_node_uuid="lxc2"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="24" priority="1000000">
@@ -391,6 +421,9 @@
       <trigger>
         <rsc_op id="14" operation="start" operation_key="container1_start_0" on_node="18node1" on_node_uuid="1"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="35" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="28">
@@ -417,10 +450,50 @@
       <trigger>
         <rsc_op id="15" operation="start" operation_key="container2_start_0" on_node="18node1" on_node_uuid="1"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="35" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="30">
     <action_set>
+      <pseudo_event id="37" operation="stonith" operation_key="stonith-lxc2-reboot" on_node="lxc2" on_node_uuid="lxc2">
+        <attributes CRM_meta_master_lxc_ms="5" CRM_meta_on_node="lxc2" CRM_meta_on_node_uuid="lxc2" CRM_meta_stonith_action="reboot" />
+        <downed>
+          <node id="lxc2"/>
+        </downed>
+      </pseudo_event>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="31">
+    <action_set>
+      <pseudo_event id="36" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1">
+        <attributes CRM_meta_master_lxc_ms="10" CRM_meta_on_node="lxc1" CRM_meta_on_node_uuid="lxc1" CRM_meta_stonith_action="reboot" />
+        <downed>
+          <node id="lxc1"/>
+        </downed>
+      </pseudo_event>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="32">
+    <action_set>
+      <pseudo_event id="35" operation="stonith_complete" operation_key="stonith_complete">
+        <attributes />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="36" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="37" operation="stonith" operation_key="stonith-lxc2-reboot" on_node="lxc2" on_node_uuid="lxc2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="33">
+    <action_set>
       <pseudo_event id="2" operation="all_stopped" operation_key="all_stopped">
         <attributes />
       </pseudo_event>
@@ -432,6 +505,9 @@
       <trigger>
         <pseudo_event id="20" operation="stop" operation_key="lxc-ms_stop_0" internal_operation_key="lxc-ms:1_stop_0"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="35" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
 </transition_graph>
diff --git a/pengine/test10/whitebox-ms-ordering.summary b/pengine/test10/whitebox-ms-ordering.summary
index d6bbaafb1..5d7c042bb 100644
--- a/pengine/test10/whitebox-ms-ordering.summary
+++ b/pengine/test10/whitebox-ms-ordering.summary
@@ -27,6 +27,9 @@ Executing cluster transition:
  * Resource action: lxc-ms          monitor on 18node2
  * Resource action: lxc-ms          monitor on 18node1
  * Pseudo action:   lxc-ms-master_demote_0
+ * Pseudo action:   stonith-lxc2-reboot on lxc2
+ * Pseudo action:   stonith-lxc1-reboot on lxc1
+ * Pseudo action:   stonith_complete
  * Resource action: container1      start on 18node1
  * Resource action: container2      start on 18node1
  * Pseudo action:   lxc-ms_demote_0
diff --git a/pengine/test10/whitebox-unexpectedly-running.dot b/pengine/test10/whitebox-unexpectedly-running.dot
index d87344a98..2915d776e 100644
--- a/pengine/test10/whitebox-unexpectedly-running.dot
+++ b/pengine/test10/whitebox-unexpectedly-running.dot
@@ -5,9 +5,14 @@
 "FAKE_start_0 18builder" [ style=bold color="green" fontcolor="black"]
 "FAKE_stop_0 18builder" -> "FAKE_start_0 18builder" [ style = bold]
 "FAKE_stop_0 18builder" -> "all_stopped" [ style = bold]
+"FAKE_stop_0 18builder" -> "stonith 'reboot' remote1" [ style = bold]
 "FAKE_stop_0 18builder" [ style=bold color="green" fontcolor="black"]
 "all_stopped" [ style=bold color="green" fontcolor="orange"]
 "remote1_monitor_30000 18builder" [ style=bold color="green" fontcolor="black"]
 "remote1_start_0 18builder" -> "remote1_monitor_30000 18builder" [ style = bold]
 "remote1_start_0 18builder" [ style=bold color="green" fontcolor="black"]
+"stonith 'reboot' remote1" -> "stonith_complete" [ style = bold]
+"stonith 'reboot' remote1" [ style=bold color="green" fontcolor="orange"]
+"stonith_complete" -> "all_stopped" [ style = bold]
+"stonith_complete" [ style=bold color="green" fontcolor="orange"]
 }
diff --git a/pengine/test10/whitebox-unexpectedly-running.exp b/pengine/test10/whitebox-unexpectedly-running.exp
index 29cd66bfe..c5272f22d 100644
--- a/pengine/test10/whitebox-unexpectedly-running.exp
+++ b/pengine/test10/whitebox-unexpectedly-running.exp
@@ -62,6 +62,33 @@
   </synapse>
   <synapse id="5">
     <action_set>
+      <pseudo_event id="8" operation="stonith" operation_key="stonith-remote1-reboot" on_node="remote1" on_node_uuid="remote1">
+        <attributes CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_stonith_action="reboot" />
+        <downed>
+          <node id="remote1"/>
+        </downed>
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="2" operation="stop" operation_key="FAKE_stop_0" on_node="18builder" on_node_uuid="5"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="6">
+    <action_set>
+      <pseudo_event id="7" operation="stonith_complete" operation_key="stonith_complete">
+        <attributes />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="8" operation="stonith" operation_key="stonith-remote1-reboot" on_node="remote1" on_node_uuid="remote1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="7">
+    <action_set>
       <pseudo_event id="1" operation="all_stopped" operation_key="all_stopped">
         <attributes />
       </pseudo_event>
@@ -70,6 +97,9 @@
       <trigger>
         <rsc_op id="2" operation="stop" operation_key="FAKE_stop_0" on_node="18builder" on_node_uuid="5"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="7" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
 </transition_graph>
diff --git a/pengine/test10/whitebox-unexpectedly-running.summary b/pengine/test10/whitebox-unexpectedly-running.summary
index f834e417a..7d5b90817 100644
--- a/pengine/test10/whitebox-unexpectedly-running.summary
+++ b/pengine/test10/whitebox-unexpectedly-running.summary
@@ -10,6 +10,8 @@ Transition Summary:
 
 Executing cluster transition:
  * Resource action: FAKE            stop on 18builder
+ * Pseudo action:   stonith-remote1-reboot on remote1
+ * Pseudo action:   stonith_complete
  * Pseudo action:   all_stopped
  * Resource action: FAKE            start on 18builder
  * Resource action: remote1         start on 18builder
